<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 items-center justify-center">
      <div class="inline-block">
        <a-input label="Mason id:" placeholder="mason id"
          :validators="letterNamesValidators" v-model="mason_id" />
        <submit-button value="find" @click="execute" />
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Masons />
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { positiveNumberValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import ComplexSqlQueries from '@/assets/ComplexQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Masons from '@/components/Masons.vue';
import { mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';
import { add_masons } from '@/components/helpers';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Masons
  },
  data() {
    return {
      letterNamesValidators: [positiveNumberValidator],
      question_str: ComplexSqlQueries[0].question,
      sql_query: ComplexSqlQueries[0].query,
      mason_id: undefined,
    }
  },
  methods: {
    ...mapMutations(['clearMasons']),
    execute() {
      axiosClient.get('complex-query/1', {headers:{n:this.mason_id}})
      .then((response) => {
        this.clearMasons()
        add_masons(response)
      })
    }
  },
  mounted() {
    this.clearMasons()
  }
}


</script>